package com.neuedu.my12306.my;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.neuedu.my12306.R;
import com.neuedu.my12306.R.layout;
import com.neuedu.my12306.R.menu;

import android.os.Bundle;
import android.app.ActionBar;
import android.app.Activity;
import android.content.Intent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;
import android.widget.SimpleAdapter;
import android.widget.Toast;

public class MyContactActivity extends Activity {
	ListView lvMyContact = null;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_my_contact);

		// ز˵
		ActionBar bar = getActionBar();
		bar.setDisplayHomeAsUpEnabled(true);

		lvMyContact = (ListView) findViewById(R.id.lvMyContact);

		// 
		final List<Map<String, Object>> data = new ArrayList<Map<String, Object>>();

		// row 1
		Map<String, Object> row = new HashMap<String, Object>();
		row.put("name", "()");
		row.put("idCard", "֤:110110199009091111");
		row.put("tel", "绰:138888888899");
		data.add(row);

		// row 2
		row = new HashMap<String, Object>();
		row.put("name", "С()");
		row.put("idCard", "֤:110110199009092222");
		row.put("tel", "绰:138888800000");
		data.add(row);

		// row 3
		row = new HashMap<String, Object>();
		row.put("name", "С(ѧ)");
		row.put("idCard", "ѧ֤:110110199009098888");
		row.put("tel", "绰:138888886666");
		data.add(row);

		// 
		// context: 
		// data: 
		// resource: в
		// from: Mapеkey
		// to: еid
		SimpleAdapter adapter = new SimpleAdapter(this, data,
				R.layout.item_my_contact, new String[] { "name", "idCard",
						"tel" }, new int[] { R.id.tvNameContact,
						R.id.tvIdCardContact, R.id.tvTelContact });

		// 
		lvMyContact.setAdapter(adapter);

		// ¼
		lvMyContact.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> parent, View view,
					int position, long id) {
				// TODO Auto-generated method stub
				Intent intent = new Intent(MyContactActivity.this,
						MyContactEditActivity.class);
				// 
				intent.putExtra("row", (Serializable) data.get(position)); // Map
				startActivity(intent);
			}
		});
	}

	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		
		// ʷ 
		Toast.makeText(MyContactActivity.this, "ˢ", Toast.LENGTH_SHORT).show();
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.my_contact, menu);
		return true;
	}

	@Override
	public boolean onMenuItemSelected(int featureId, MenuItem item) {
		// TODO Auto-generated method stub
		// ˵¼
		switch (item.getItemId()) {
		case android.R.id.home:
			finish();
			break;
		case R.id.mn_contact_add:
			// תû
			Intent intent = new Intent(MyContactActivity.this,
					MyContactNewActivity.class);
			startActivity(intent);
			break;
		}

		return super.onMenuItemSelected(featureId, item);
	}

}
