package com.neuedu.my12306.my;

import java.lang.reflect.Field;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.neuedu.my12306.R;
import com.neuedu.my12306.R.layout;
import com.neuedu.my12306.R.menu;

import android.os.Bundle;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.text.TextUtils;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.SimpleAdapter;

public class MyContactEditActivity extends Activity {
	ListView lvMyContactEdit;
	List<Map<String, Object>> data = null;
	SimpleAdapter adapter = null;
	Button btnMyContactEditSave = null;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_my_contact_edit);

		lvMyContactEdit = (ListView) findViewById(R.id.lvMyContactEdit);
		btnMyContactEditSave = (Button) findViewById(R.id.btnMyContactEditSave);

		// 
		Intent intent = getIntent();
		Map<String, Object> contact = (Map<String, Object>) intent
				.getSerializableExtra("row");

		// ݲ
		data = new ArrayList<Map<String, Object>>();

		// row1: 
		Map<String, Object> row1 = new HashMap<String, Object>();
		String name = (String) contact.get("name");
		row1.put("key1", "");
		row1.put("key2", name.split("\\(")[0]);
		row1.put("key3", R.drawable.forward_25);
		data.add(row1);

		// row2: ֤
		Map<String, Object> row2 = new HashMap<String, Object>();
		String idCard = (String) contact.get("idCard");
		row2.put("key1", "֤");
		row2.put("key2", idCard.split(":")[0]);
		row2.put("key3", null);
		data.add(row2);

		// row3: ֤
		Map<String, Object> row3 = new HashMap<String, Object>();
		row3.put("key1", "֤");
		row3.put("key2", idCard.split(":")[1]);
		row3.put("key3", null);
		data.add(row3);

		// row4: ˿
		Map<String, Object> row4 = new HashMap<String, Object>();
		row4.put("key1", "˿");
		row4.put("key2", name.split("\\(")[1].split("\\)")[0]);
		row4.put("key3", R.drawable.forward_25);
		data.add(row4);

		// row5: 绰
		Map<String, Object> row5 = new HashMap<String, Object>();
		String tel = (String) contact.get("tel");
		row5.put("key1", "绰");
		row5.put("key2", tel.split(":")[1]);
		row5.put("key3", R.drawable.forward_25);
		data.add(row5);

		// 
		adapter = new SimpleAdapter(MyContactEditActivity.this, data,
				R.layout.item_my_contact_edit, new String[] { "key1", "key2",
						"key3" }, new int[] { R.id.tvMyContactEditKey,
						R.id.tvMyContactEditValue, R.id.imgMyContactEditFlg });
		lvMyContactEdit.setAdapter(adapter);

		lvMyContactEdit.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView<?> parent, View view,
					final int position, long id) {
				// TODO Auto-generated method stub
				switch (position) {
				case 0:
					final EditText edtName = new EditText(
							MyContactEditActivity.this);
					edtName.setText((String) (data.get(position).get("key2")));
					edtName.selectAll(); // Ĭѡ

					new AlertDialog.Builder(MyContactEditActivity.this)
							.setIcon(android.R.drawable.ic_dialog_info)
							.setTitle("")
							.setView(edtName)
							.setPositiveButton("ȷ",
									new DialogInterface.OnClickListener() {

										@Override
										public void onClick(
												DialogInterface dialog,
												int which) {
											// TODO Auto-generated method stub
											// ֤
											String name = edtName.getText()
													.toString();
											if (TextUtils.isEmpty(name)) {
												// öԻԶر
												setClosable(dialog, false);

												edtName.setError("");
												edtName.requestFocus();

											} else {
												// öԻԶر
												setClosable(dialog, true);

												data.get(position).put(
														"key2",
														edtName.getText()
																.toString());
												// ListView
												adapter.notifyDataSetChanged();
											}
										}
									})
							.setNegativeButton("ȡ",
									new DialogInterface.OnClickListener() {

										@Override
										public void onClick(
												DialogInterface dialog,
												int which) {
											// TODO Auto-generated method stub
											// öԻԶر
											setClosable(dialog, true);

										}
									}).show();

					break;
				case 3:
					final String[] types = new String[] { "", "ѧ", "ͯ",
							"" };
					String key2 = (String) (data.get(position).get("key2"));
					int idx = 0;
					for (int i = 0; i < types.length; i++) {
						if (types[i].equals(key2)) {
							idx = i;
							break;
						}
					}

					new AlertDialog.Builder(MyContactEditActivity.this)
							.setIcon(android.R.drawable.ic_dialog_alert)
							.setTitle("ѡ˿")
							.setSingleChoiceItems(types, idx,
									new DialogInterface.OnClickListener() {

										@Override
										public void onClick(
												DialogInterface dialog,
												int which) {
											// TODO Auto-generated method stub
											data.get(position).put("key2",
													types[which]);
											adapter.notifyDataSetChanged();

											dialog.dismiss();
										}
									}).setNegativeButton("ȡ", null).show();

					break;
				case 4:
					break;
				}
			}

		});

		btnMyContactEditSave.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				// 1.ݱ浽
				// 2.finish()
				finish();
			}
		});
	}

	private void setClosable(DialogInterface dialog, boolean b) {
		Field field;
		try {
			field = dialog.getClass().getSuperclass()
					.getDeclaredField("mShowing");
			field.setAccessible(true);
			field.set(dialog, b);
		} catch (NoSuchFieldException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		}
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.my_contact_edit, menu);
		return true;
	}

}
