package com.neuedu.my12306;

import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.cookie.Cookie;
import org.apache.http.impl.client.AbstractHttpClient;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.params.CoreConnectionPNames;
import org.apache.http.util.EntityUtils;
import org.xmlpull.v1.XmlPullParser;
import org.xmlpull.v1.XmlPullParserException;

import com.neuedu.my12306.utils.CONSTANT;
import com.neuedu.my12306.utils.Md5Utils;
import com.neuedu.my12306.utils.NetUtils;

import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.app.Activity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.text.Html;
import android.text.TextUtils;
import android.text.method.LinkMovementMethod;
import android.util.Log;
import android.util.Xml;
import android.view.Menu;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

public class LoginActivity extends Activity {

	Button btnLogin;
	TextView tvLostPassword = null;
	EditText edtUsername = null;
	EditText edtPassword = null;
	CheckBox ckLogin = null;
	final int LoginSuccess=1;
	final int LoginFaile=0;
	
	Handler handler=new Handler(){
		public void handleMessage(android.os.Message msg){
			String str=(String) msg.obj;
			switch(msg.what){
			case 1:
				if(msg.arg1==LoginSuccess){
					//浽ͻsharepreferencesУӿжҪjessionid
					SharedPreferences pref = getSharedPreferences("user",
							Context.MODE_PRIVATE);
					Editor editor = pref.edit(); // ༭
					editor.putString("JESSIONID", msg.obj.toString());					
					editor.commit(); 
					
					 
					// ¼ѡԶ¼¼û
					if (ckLogin.isChecked()) {
						// 0: mode_private
						SharedPreferences pref1 = getSharedPreferences("user",
								Context.MODE_PRIVATE);
						Editor editor1 = pref1.edit(); // ༭
						editor1.putString("username", edtUsername.getText()
								.toString());
						editor1.putString("password", edtPassword.getText()
								.toString());
						editor1.commit(); // һҪύ

					} else {
						// ǰĵ¼Ϣ
						SharedPreferences pref1 = getSharedPreferences("user",
								Context.MODE_PRIVATE);
						Editor editor1 = pref1.edit();
						editor1.remove("username");
						editor1.remove("password");
						editor1.commit();
					} 
					Intent intent = new Intent();
					intent.setClass(LoginActivity.this, MainActivity.class);
					startActivity(intent);
				}
                if(msg.arg1==LoginFaile){
					Toast.makeText(LoginActivity.this,"¼ʧ" , 3000).show();
				}
				break;
			case 2:
				Toast.makeText(LoginActivity.this,"쳣¼ʧ" , 3000).show();
				break;
				
			}			
			if(!TextUtils.isEmpty(str)){
				edtUsername.setError(str);
				edtPassword.requestFocus();
			}
		};
		
	};

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_login);

		tvLostPassword = (TextView) findViewById(R.id.tvLostPassword);
		edtUsername = (EditText) findViewById(R.id.edtUsername);
		edtPassword = (EditText) findViewById(R.id.edtPassword);
		ckLogin = (CheckBox) findViewById(R.id.ckLogin);

		// ?
		tvLostPassword
				.setText(Html
						.fromHtml("<a href=\"http://www.12306.cn/lostPassword\">룿</a>"));
		tvLostPassword.setMovementMethod(LinkMovementMethod.getInstance());

		// ȡ
		btnLogin = (Button) findViewById(R.id.btnLogin);
		// 󶨼
		btnLogin.setOnClickListener(new OnClickListener() {

			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				Log.d("My12306", "Login Button Click");

				if (TextUtils.isEmpty(edtUsername.getText().toString())) {
					edtUsername.setError("û");
					edtUsername.requestFocus();
				} else if (TextUtils.isEmpty(edtPassword.getText().toString())) {
					edtPassword.setError("");
					edtPassword.requestFocus();
				} else {
					//
					
					if(!NetUtils.check(LoginActivity.this)){
						Toast.makeText(LoginActivity.this, "Ǹǰ粻",3000).show();
						return;
					}
					
					//ʾ¼ȶԻ
					ProgressDialog.show(LoginActivity.this,"¼","ڵ¼");									
					//¼߳
					
					new Thread(new Runnable(){
						
                      private String value;
                      private UrlEncodedFormEntity entity;
                      
						@Override
						public void run() {
							// TODO Auto-generated method stub	
							//ʵHttpClient
							HttpClient client=new DefaultHttpClient();
							//ʵHttpPost
							HttpPost post=new HttpPost(CONSTANT.HOST+"/Login");
							//
							List<BasicNameValuePair> params =
									new ArrayList<BasicNameValuePair>();
							params.add(new BasicNameValuePair("username", 
									edtUsername.getText().toString()));
							params.add(new BasicNameValuePair("password", 
									Md5Utils.MD5(edtPassword.getText().toString())));						
							try{
								entity=new UrlEncodedFormEntity(params,"UTF-8");								
								post.setEntity(entity);								
								//ʱĲ
								client.getParams().setParameter
								(CoreConnectionPNames.CONNECTION_TIMEOUT,CONSTANT.REQUEST_TIMEOUT );
								
								client.getParams().setParameter
								(CoreConnectionPNames.CONNECTION_TIMEOUT,CONSTANT.SO_TIMEOUT);
								
								
								//ִ
								HttpResponse response=client.execute(post);
								if(response.getStatusLine().getStatusCode()==200){
									//200ʾɹ
								//String strResponse=EntityUtils.toString(response.getEntity());
								//
								InputStream is=response.getEntity().getContent();
								XmlPullParser parser=Xml.newPullParser();
								parser.setInput(is,"UTF-8");
								int eventType=parser.getEventType();
								String result="";
								while (eventType!=XmlPullParser.END_DOCUMENT){
									switch (eventType) {
									case XmlPullParser.START_TAG:
										//ַһҪequals
										if("result".equals(parser.getName())){
											
											result=parser.nextText();
											Log.d("result",result);
																					
										}										
										break;

									default:
										break;
									}
										eventType=parser.next();
									}
									//ȡJessionid
									List<Cookie> cookies=((AbstractHttpClient) client).getCookieStore()
									   .getCookies();
									for(Cookie cookie:cookies){
										if("JESSIONID".equals(cookie.getName())){
											value=cookie.getValue();
											break;
										}
									}
									
									//1¼ɹ,"0"֤ʧ
									if(result.equals("\"1\"")){
										Message msg=new Message();
										msg.what=1;
										msg.obj=value;
										msg.arg1=LoginSuccess;
										handler.sendMessage(msg);
										
									}else if(result.equals("\"0\"")) {
										Message msg=new Message();
										msg.what=1;
										msg.arg1=LoginFaile;
										handler.sendMessage(msg);										
									}
								}							
								
							}catch(UnsupportedEncodingException e){
								e.printStackTrace();
								Message msg=new Message();
								msg.what=2;
								handler.sendMessage(msg);
																
							}catch(ClientProtocolException e){
								e.printStackTrace();
								Message msg=new Message();
								msg.what=2;								
								handler.sendMessage(msg);
							}catch(IOException e){
								e.printStackTrace();
								Message msg=new Message();
								msg.what=2;								
								handler.sendMessage(msg);
							
							}catch(XmlPullParserException e){
								e.printStackTrace();
								Message msg=new Message();
								msg.what=2;								
								handler.sendMessage(msg);
							}finally{
								client.getConnectionManager();															
							}
							}
					}).start();

					// ʽͼ
					/*Intent intent = new Intent();
					intent.setClass(LoginActivity.this, MainActivity.class);
					startActivity(intent);*/

					// ʽͼ
					// Intent intent = new Intent();
					// intent.setAction("aa");
					// intent.addCategory("bb");
					// startActivity(intent);

					// رLoginActivity
					//finish();
				}

			}
		});
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.login, menu);
		return true;
	}

}
